Added ability for bitrate and audio options to override handbrake preset values
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset drc="0.0"
48 typeset -i default_aid=128
49 typeset -i aid_override=-1
50 typeset -i force_onepass_mode=0
51 typeset -i eject_disk=1
52 typeset -i keep_isofile=0
53 typeset -i keep_vobfile=0
54 typeset -i keep_dvdfolder=0
55 typeset -i keep_intermediate_files=0
56 typeset -i make_final_dest_vob=0
57 typeset -i make_final_dest_iso=0
58 typeset -i make_final_dest_folder=0
59 typeset -i make_final_dest_comp=0
60 typeset -i errors=0
61 typeset -i show_usage=0
62 typeset -i mirror_mode=0
63 typeset -i target_bitrate=2000
64 typeset -i target_size=0
65 typeset -i audio_2ch=0
66 typeset -i audio_6ch=1
67 typeset -i invalid_feature_title=0
68 typeset -i feature_title_override=0
69 typeset -i mplayer_dumpstream_incompatibility=0
70 typeset -i custom_bitrate=0
71 typeset -i custom_audio_2ch=0
72 typeset -i custom_audio_6ch=0
73
74 ##############################################################################
75 # Local Machine Settings:
76 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
77 # and the local conf file created by each local machine (rip_dvd.conf)
78 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
79 # This will allow you to override all the default values to meet your needs
80 # in a way that won't get clobbered when you pull updates from my GIT repo.
81 ##############################################################################
82 config="${0%/*}/rip_dvd.conf"
83
84 # The config file will be searched for in the following location order:
85 found_config=0
86
87 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
88 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
89
90 # 2) /path/to/rip_dvd/script/rip_dvd.conf
91 [ -e "${config}" ] && found_config=1 && . "${config}"
92
93 # 3) /etc/rip_dvd.conf
94 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
95
96 # 4) $PWD/rip_dvd.conf
97 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
98
99 # Check to make sure we found the config file
100 if [ $found_config -eq 0 ]; then
101   echo "-E- Unable to find the rip_dvd.conf file: $config"
102   exit 1
103 fi
104
105 ##############################################################################################
106 # Command line processing
107 ##############################################################################################
108 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
109 do
110     case $opt in
111         (n)     dvdname=$OPTARG;;
112         (d)     dest=$OPTARG;;
113         (b)     target_bitrate=$OPTARG; custom_bitrate=1;;
114         (s)     target_size=$OPTARG;;
115         (2)     audio_2ch=1; custom_audio_2ch=1;;
116         (6)     audio_6ch=1; custom_audio_6ch=1;;
117         (1)     force_onepass_mode=1;;
118         (v)     make_final_dest_vob=1;;
119         (i)     make_final_dest_iso=1;;
120         (f)     make_final_dest_folder=1;; 
121         (z)     make_final_dest_comp=1;;
122         (e)     encoder=$OPTARG;;
123         (m)     mirror_mode=1;;
124         (k)     keep_intermediate_files=1;;
125         (t)     feature_title_override=$OPTARG;;
126         (a)     aspect=$OPTARG;;
127         (p)     profile=$OPTARG;;
128         (x)     extension=$OPTARG;;
129         (j)     eject_disk=$OPTARG;;
130         (l)     aid_override=$OPTARG;;
131         (r)     drc=$OPTARG;;
132         (w)     set -x;;
133         (h)     show_usage=1;;
134         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
135         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
136     esac
137 done
138
139 shift $((OPTIND-1))
140
141 function usage() {
142     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
143     echo >&2 "Revision $REV"
144     echo >&2 "Options:"
145     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
146     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
147     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
148     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
149     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
150     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
151     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
152     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
153     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
154     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
155     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
156     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
157     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
158     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
159     echo >&2 "                 Handbrake Only Encoder Profiles:"
160     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
161     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
162     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
163     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
164     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
165     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
166     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
167     echo >&2 "                 The default operation is non-mirror mode where only the main"
168     echo >&2 "                 feature title will be ripped."
169     echo >&2 "   -v            Make the final image a DVD VOB file"
170     echo >&2 "   -i            Make the final image a DVD ISO file"
171     echo >&2 "   -f            Make the final image a DVD folder"
172     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
173     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
174     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
175     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
176     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
177     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
178     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
179     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
180     echo >&2 "   -j <n>        Eject the disk:"
181     echo >&2 "                 - 0 = do not eject the disk"
182     echo >&2 "                 - 1 = eject after the entire script is done (default)"
183     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
184     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
185     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
186     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
187     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
188     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
189     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
190     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
191     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
192     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
193     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
194     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
195     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
196     echo >&2 ""
197     exit 2
198 }
199
200 if (($errors)) || (($show_usage))
201 then
202   usage
203 fi
204
205 # Sanity Check - Command Line Options 
206 if [ "$dest" == "" ]; then
207   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
208   usage
209 fi
210
211 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
212    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
213     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
214     make_final_dest_comp=1
215 fi
216
217 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
218   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
219   usage
220 fi
221
222 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
223   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
224   usage
225 fi
226
227 if [ $mirror_mode -eq 1 ]; then
228   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
229      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
230     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
231     usage
232   fi
233 fi
234
235 # Make handbrake the default encoder if not specified and we can find it
236 if [ -z "$encoder" ]; then
237   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
238   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
239   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
240   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
241   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
242 fi
243
244 # Sanity check the profile selection
245 if [[ "$encoder" == "mencoder" ]]; then
246   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
247 fi
248
249 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
250   echo "-E- Invalid encoder specified: $encoder"
251   exit 1
252 fi
253
254 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
255 if [ "$aspect" != "" ]; then
256   echo "$aspect" | grep -q "x"
257   if [ $? == 0 ]; then
258     echo "-E- You must specify the aspect option with a value whose format is W:H"
259     exit 1
260   fi
261   echo "$aspect" | grep -q ":"
262   if [ $? != 0 ]; then
263     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
264     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
265   else
266     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
267     if [ "$encoder" == "handbrake" ]; then
268        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
269        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
270        SCALE="-w $WIDTH -l $HEIGHT"
271     fi
272   fi
273 fi
274
275 # Sanity Check - Key executables
276 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
277 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
278 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
279 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
280 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
281 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
282 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
283 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
284 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
285 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
286 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
287 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
288 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
289
290 ##############################################################################################
291
292 typeset -i ripdvd
293 if [ -z "$dvdname" ]; then
294
295   # make sure the DVD device is accessible
296   volname $dev > /dev/null 2>&1
297   if [ $? != 0 ]; then
298     echo "-E- Can't access the DVD device $dev"
299     exit 1
300   fi
301   # now capture the volume name from the device
302   dvdname=`volname $dev | awk '{ print $1 }'`
303   ripdvd=1
304
305 else 
306
307   # check to see if dvdname is a full path to a real directory
308   # if it is, set dvdname and dvdpath appropriately
309   if [ -d "$dvdname" ]; then
310     dvdpath="$dvdname"
311     dvdname=`basename "$dvdname"`
312     keep_dvdfolder=1
313     if [ -z "$dvdname" ]; then
314      echo "-E- Unable to extract dvdname from path: $dvdpath"
315      exit 1
316     fi
317     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
318       echo "-E- You must supply a full path to a valid DVD folder with this option"
319       exit 1
320     fi
321   fi
322
323   # Check to see if dvdname is a full path to a file
324   if [ -f "$dvdname" ]; then
325     valid_file=0
326
327     # check to see if dvdname is a full path to an MPG2 (VOB) file
328     # if it is, set dvdname and vobfile appropriately
329     file "$dvdname" | grep -q "MPEG"
330     if [ $? == 0 ]; then
331       # It is a valid MPEG2 file, now strip the extension off our dvdname
332       vobfile="$dvdname"
333       dvdname=`basename "$dvdname"`
334       dvdname=${dvdname%.[^.]*}
335       keep_vobfile=1
336       valid_file=1
337     fi
338
339     # check to see if dvdname is a full path to an ISO file
340     # if it is, set dvdname and isofile appropriately
341     file "$dvdname" | grep -q -e "ISO" -e "UDF"
342     if [ $? == 0 ]; then
343       # It is a valid ISO file, now strip the extension off our dvdname
344       isofile="$dvdname"
345       dvdname=`basename "$dvdname"`
346       dvdname=${dvdname%.[^.]*}
347       keep_isofile=1
348       valid_file=1
349     fi    
350
351     # check to see if dvdname is a full path to an ISO file
352     # if it is, set dvdname and isofile appropriately
353     file "$dvdname" | grep -q -e "VOB"
354     if [ $? == 0 ]; then
355       # It is a valid VOB file, now strip the extension off our dvdname
356       vobfile="$dvdname"
357       dvdname=`basename "$dvdname"`
358       dvdname=${dvdname%.[^.]*}
359       keep_vobfile=1
360       valid_file=1
361     fi    
362
363     # If we didn't find a handler for the file above, complain
364     if [ $valid_file -eq 0 ]; then
365       echo "-E- Unsupported file type: $vobfile"
366       exit 1
367     fi
368
369   # Throw an error if we can't find what the -n option is pointing to
370   else 
371     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
372     exit 1
373   fi
374
375   # Set the ripdvd flag to false since we aren't ripping a DVD disk
376   ripdvd=0
377
378   # Since we aren't ripping a DVD disk, don't eject anything either
379   eject_disk=0
380
381 fi
382
383 # remove bad characters from the dvdname
384 dvdname=${dvdname%.} # remove trailing '.' character
385
386 # add the suffix extension to the end of the dvdname
387 dvdname=$dvdname$extension
388
389 # make a "safe" dvdname (remove special characters)
390 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
391
392 # Make sure we have a non-empty dvdname
393 if [ -z "$dvdname" ]; then
394   echo "-E- unable to determine dvdname"
395   exit 1
396 fi
397
398 # make sure our vobfile value is set
399 if [ -z "$vobfile" ]; then
400   vobfile="$dest/$dvdname.VOB"
401 fi
402
403 # set up some variables to hold various logfiles
404 logfile="$logdir/$dvdname.log"
405 passlogfile="$tmpdir/$safedvdname.log"
406 ddrescuelog=`tempfile`
407 dvdauthorlog=`tempfile`
408 encodelog=`tempfile`
409 dumplog=`tempfile`
410
411 # create the tmpdir if it doesn't already exist
412 if [ ! -d "$tmpdir" ]; then
413   mkdir -p "$tmpdir"
414   if [ $? != 0 ]; then
415     echo "-E- Unable to create the tmpdir: $tmpdir"
416     exit 1
417   fi
418 fi
419
420 # create the logdir if it doesn't already exist
421 if [ ! -d "$logdir" ]; then
422   mkdir -p "$logdir"
423   if [ $? != 0 ]; then
424     echo "-E- Unable to create the logdir: $logdir"
425     exit 1
426   fi
427 fi
428
429 ##############################################################################################
430 # cleanup functions
431 ##############################################################################################
432 cleanup() { 
433   if [ $keep_intermediate_files -eq 0 ]; then
434     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
435     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
436     [[ -e "$encodelog" ]] && rm -f "$encodelog"
437     [[ -e "$dumplog" ]] && rm -f "$dumplog"
438   else
439     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
440     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
441     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
442     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
443   fi
444   echo ""
445 }
446
447 fatal_and_exit() {
448   if [[ -z "$1" ]]; then
449     msg="-E- control-c killed us"
450   else
451     msg=$1
452   fi
453   echo -e 2>&1 "$msg" | tee -a "$logfile"
454   if [[ -n "$mailto" ]]; then
455     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
456   fi
457   keep_intermediate_files=1
458   exit 1
459 }
460
461 # Call our cleanup functions on INT and EXIT signals
462 trap fatal_and_exit INT
463 trap cleanup EXIT
464
465 ##############################################################################################
466 # processing functions
467 ##############################################################################################
468
469 # encode the vob file into a compressed file format using handbrake
470 function encode_vob_file_handbrake {
471   
472   # declare some globals
473   typeset handbrake_cli=""
474   typeset handbrake_video_encoder_opts=""
475   typeset filetype=""
476   typeset handbrake_audio_opts=""
477   typeset hb_profile=""
478
479   # Set a variable that we will use later to determine if we found a handler for $profile or not
480   typeset -i found_profile=0    
481
482   # For a given profile, to override the 2 pass behavior to be single pass,
483   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
484   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
485   PASSES="-2"
486
487   # Set our DRC option
488   DRC="-D $drc"
489
490   # Check the global force_onepass_mode. If it is set, change our variables appropriately
491   # to force 1-pass encoding across all profiles.
492   if [ $force_onepass_mode -eq 1 ]; then
493     PASSES=""
494   fi
495
496   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
497   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
498
499   # XVID profile
500   if [[ "$profile" =~ "xvid" ]]; then
501     found_profile=1
502     handbrake_cli="$handbrake_xvid"
503     final_output_file="$dest/$dvdname.avi"
504     filetype="avi"
505
506     # Very High Quality (16fps)
507     if [ "$profile" == "xvidvhq" ]; then
508       handbrake_opts[0]="-f avi"
509       handbrake_opts[1]="-b $target_bitrate"
510       handbrake_opts[2]="-e xvid"
511       handbrake_opts[3]="-T"
512       handbrake_opts[4]="-5"
513       handbrake_opts[5]="-8"
514     fi
515     # High Quality (20fps)
516     if [ "$profile" == "xvidhq" ]; then
517       handbrake_opts[0]="-f avi"
518       handbrake_opts[1]="-b $target_bitrate"
519       handbrake_opts[2]="-e ffmpeg"
520       handbrake_opts[3]="-T"
521       handbrake_opts[4]="-5"
522     fi
523     # Fast (28fps)
524     if [ "$profile" == "xvid" ]; then
525       handbrake_opts[0]="-f avi"
526       handbrake_opts[1]="-b $target_bitrate"
527       handbrake_opts[2]="-e ffmpeg"
528       handbrake_opts[3]="-T"
529     fi
530   fi
531
532   # MP4 profile
533   if [[ "$profile" =~ "mp4" ]]; then
534     found_profile=1
535     handbrake_cli="$handbrake_mp4"
536     final_output_file="$dest/$dvdname.mp4"
537     PASSES=""
538
539     # Handle custom parameter overrides
540     if [ $custom_bitrate == 1 ]; then
541       handbrake_opts[0]="-b $target_bitrate"
542     fi
543     if [ $custom_audio_2ch == 0 ]; then
544       audio_2ch=0
545     fi
546     if [ $custom_audio_6ch == 0 ]; then
547       audio_6ch=0
548     fi
549
550     # Very High Quality
551     if [ "$profile" == "mp4vhq" ]; then
552       profile="hb_High_Profile"
553     fi
554     # High Quality
555     if [ "$profile" == "mp4hq" ]; then
556       profile="hb_Normal"
557     fi
558     # Fast
559     if [ "$profile" == "mp4" ]; then
560       profile="hb_Classic"
561     fi
562   fi
563
564   # iphone and ipod MP4 profiles
565   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
566     found_profile=1
567     handbrake_cli="$handbrake_mp4"
568     final_output_file="$dest/$dvdname.mp4"
569     PASSES=""
570
571     # Handle custom parameter overrides
572     if [ $custom_bitrate == 1 ]; then
573       handbrake_opts[0]="-b $target_bitrate"
574     fi
575     if [ $custom_audio_2ch == 0 ]; then
576       audio_2ch=0
577     fi
578     if [ $custom_audio_6ch == 0 ]; then
579       audio_6ch=0
580     fi
581
582     # iphone
583     if [ "$profile" == "iphone" ]; then
584       profile="hb_iPhone_&_iPod_Touch"
585     fi
586     # ipod
587     if [ "$profile" == "ipod" ]; then
588       profile="hb_iPod"
589     fi
590
591   fi
592   
593   # Predefined Handbrake Profile Handling
594   if [[ "$profile" =~ "hb" ]]; then
595     found_profile=1
596     handbrake_cli="$handbrake_mp4"
597     final_output_file="$dest/$dvdname.mp4"
598     PASSES=""
599
600     # Handle custom parameter overrides
601     if [ $custom_bitrate == 1 ]; then
602       handbrake_opts[0]="-b $target_bitrate"
603     fi
604     if [ $custom_audio_2ch == 0 ]; then
605       audio_2ch=0
606     fi
607     if [ $custom_audio_6ch == 0 ]; then
608       audio_6ch=0
609     fi
610     
611     # extract the HandBrake Profile name from $profile
612     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
613   fi
614
615   # Make sure we found a handler for the given profile
616   if [ $found_profile -eq 0 ]; then
617     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
618   fi
619
620   # setup our audio option
621   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
622     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
623   fi
624   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
625     handbrake_audio_opts="-E ac3 -6 auto"
626   fi
627   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
628     handbrake_audio_opts="-E faac -6 dpl2"
629   fi
630   if [ -n "$track" ]; then
631     handbrake_audio_opts="$handbrake_audio_opts -a $track"
632   fi
633
634   # Convert our array of opts into a string
635   for OPTS in "${video_encoder_opts[@]}"; do 
636     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
637   done
638   if [ -n "$handbrake_video_encoder_opts" ]; then
639     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
640   fi
641   for OPTS in "${handbrake_opts[@]}"; do 
642     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
643   done
644
645   # Append "global" command line options
646   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
647   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
648   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
649   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
650
651   # Execute the handbrake command to encode the video
652   if [ -n "$hb_profile" ]; then
653     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
654     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
655     handbrake_retval=$?
656   else 
657     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
658     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
659     handbrake_retval=$?
660   fi
661   if [ $handbrake_retval != 0 ]; then
662     fatal_and_exit "-E- Unhandled handbrake error"
663   fi
664
665   # Concatenate the encode log to our main log file, greping out unwanted lines
666   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
667   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
668   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
669 }
670
671 # encode the vob file into a compressed file format using mencoder
672 function encode_vob_file_mencoder {
673
674   # Set a variable that we will use later to determine if we found a handler for $profile or not
675   typeset -i found_profile=0
676
677   # For a given profile, to override the 2 pass behavior to be single pass,
678   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
679   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
680   PASSES="1 2"
681
682   # Declare our default 2 pass variables
683   passlogfile_opt="-passlogfile $passlogfile"
684   pass_opt="pass=%PASS"
685
686   # Check the global force_onepass_mode. If it is set, change our variables appropriately
687   # to force 1-pass encoding across all profiles.
688   if [ $force_onepass_mode -eq 1 ]; then
689     PASSES="2"
690     passlogfile_opt=""
691     pass_opt=""    
692   fi
693
694   # XVID profile
695   if [[ "$profile" =~ "xvid" ]]; then
696     found_profile=1
697     final_output_file="$dest/$dvdname.avi"
698     mencoder_general_opts="$lang_opts $passlogfile_opt"
699     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
700     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
701     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
702
703     # Very High Quality (16fps)
704     if [ "$profile" == "xvidvhq" ]; then
705       video_encoder_opts[0]="bitrate=$target_bitrate"
706       video_encoder_opts[1]="threads=$mencoder_threads"
707       video_encoder_opts[2]="chroma_opt"
708       video_encoder_opts[3]="vhq=4"
709       video_encoder_opts[4]="bvhq=1"
710       video_encoder_opts[5]="quant_type=mpeg"
711       video_encoder_opts[6]="autoaspect"
712     fi
713     # High Quality (20fps)
714     if [ "$profile" == "xvidhq" ]; then
715       video_encoder_opts[0]="bitrate=$target_bitrate"
716       video_encoder_opts[1]="threads=$mencoder_threads"
717       video_encoder_opts[2]="chroma_opt"
718       video_encoder_opts[3]="vhq=2"
719       video_encoder_opts[4]="bvhq=1"
720       video_encoder_opts[5]="quant_type=mpeg"
721       video_encoder_opts[6]="autoaspect"
722     fi
723     # Fast (28fps)
724     if [ "$profile" == "xvid" ]; then
725       video_encoder_opts[0]="bitrate=$target_bitrate"
726       video_encoder_opts[1]="threads=$mencoder_threads"
727       video_encoder_opts[2]="vhq=0"
728       video_encoder_opts[3]="turbo"
729       video_encoder_opts[4]="autoaspect"
730     fi
731
732     for OPTS in "${video_encoder_opts[@]}"; do 
733       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
734     done
735
736     if [ $audio_2ch -eq 0 ]; then
737       # These options produce good 6 channel audio for linux and windows
738       mencoder_audio_opts="-oac copy"
739       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
740       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
741       mencoder_audioch_opts[1]="-af channels=6"
742       mencoder_audioch_opts[2]=""
743     else
744       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
745       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
746       mencoder_audioch_opts[0]=""
747     fi
748  
749   fi
750
751   # iphone and ipod MP4 profiles
752   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
753     found_profile=1
754     if [ "$profile" == "iphone" ]; then
755       # SCALE: 480x320
756       # scale width to 480, set height appropriately, but keep a multiple of 16
757       #SCALE=",scale=480:-10"
758       # scale the video down however far is necessary to fit in 480x320
759       SCALE=",dsize=480:320:0,scale=-8:-8"
760     else
761       # SCALE: 320x240
762       # scale width to 320, set height appropriately, but keep a multiple of 16
763       #SCALE=",scale=320:-10"
764       # scale the video down however far is necessary to fit in 320x240
765       SCALE=",dsize=320:240:0,scale=-8:-8"
766     fi
767     final_output_file="$dest/$dvdname.mp4"
768     mencoder_general_opts="$lang_opts $passlogfile_opt"
769     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
770     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
771     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
772     video_encoder_opts[0]="bitrate=$target_bitrate"
773     video_encoder_opts[1]="threads=$mencoder_threads"
774     video_encoder_opts[2]="vbv_maxrate=1500"
775     video_encoder_opts[3]="vbv_bufsize=2000"
776     video_encoder_opts[4]="nocabac"
777     video_encoder_opts[5]="me=umh"
778     video_encoder_opts[6]="subq=6"
779     video_encoder_opts[7]="frameref=6"
780     video_encoder_opts[8]="trellis=1"
781     video_encoder_opts[9]="level_idc=30"
782     video_encoder_opts[10]="global_header"
783     video_encoder_opts[11]="bframes=0"
784     video_encoder_opts[12]="partitions=all"
785     for OPTS in "${video_encoder_opts[@]}"; do 
786       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
787     done
788
789     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
790     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
791   fi
792
793   if [ $found_profile -eq 0 ]; then
794     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
795   fi
796
797   # Do not edit this line. $mencoder_video_encoder_opts must be last
798   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
799   mencoder_retval=0
800
801   for PASS in $PASSES
802   do 
803     # Set some options based on which pass we are in
804     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
805     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
806     [ $PASS -eq 1 ] && output_file="/dev/null"
807     [ $PASS -eq 2 ] && output_file="$final_output_file"
808   
809     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
810     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
811     do
812       echo -e "   Encoding pass $PASS"
813       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
814       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
815       mencoder_retval=$? 
816       grep -q "\[channels\] Invalid" $encodelog
817       if [ $? != 0 ]; then          
818         break;
819       else
820         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
821       fi
822     done
823       
824     if [ $mencoder_retval != 0 ]; then
825       fatal_and_exit "-E- Unhandled mencoder error"
826     fi
827
828     # Concatenate the encode log to our main log file, greping out unwanted lines
829     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
830
831   done
832 }
833
834 function make_dvd_iso_image {
835
836   isofile="$1"
837
838   # check to see if we have a dvdpath to rip from instead of $dev
839   if [ -z "$dvdpath" ]; then
840     # load the CSS codes in the DVD drive 
841     lsdvd $dev >> "$logfile"
842     if [ $? != 0 ]; then
843       fatal_and_exit "-E- lsdvd $dev failed" 
844     fi
845
846     # read the DVD, ignoring/skipping CRC errors
847     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
848     if [ $? != 0 ]; then
849       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
850     fi
851     cat "$ddrescuelog" >> "$logfile"
852   else
853     # rip from a path instead
854     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
855   fi
856 }
857
858 function make_dvd_iso_image_from_folder {
859   
860   src="$1"
861   dst="$2"
862   handle_error=$3
863   
864   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
865
866   # make an iso image out of our directory
867   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
868   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
869
870   # set the audio languages from the iso if it exists and is non-zero in size
871   if [ -s "$dst" ]; then
872     get_feature_title "$dst"
873     get_audio_id_from_iso "$dst"
874   fi
875
876   # make sure we were able to create the iso image from the folder given to us
877   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
878     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
879     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
880     # remove the bad iso file
881     [[ -e "$dst" ]] && rm -f "$dst"
882     # get the feature title from the DVD folder
883     get_feature_title "$dvdpath"
884     # create our main VOB file from the ISO
885     create_main_vob_with_mplayer "$dvdpath" 
886     # get our audio id from the VOB file
887     get_audio_id_from_vob "$vobfile"
888   fi
889 }
890
891 function make_dvdbackup_folder_image {
892   # extract the feature title from the DVD image
893   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
894   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
895   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
896   if [ $? != 0 ]; then
897     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
898   fi
899 }
900
901 function make_dvdauthor_folder_image {
902   # create a new DVD video of the feature title
903   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
904   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
905   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
906   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
907
908   # There is a chance that dvdauthor won't like some of the VOBs.
909   # We can't tell ahead of time which ones it will choke on. 
910   # So, we need to run it over and over again until it can process
911   # all the VOBs. If it can't handle one of them, run it through
912   # mencoder to fix it and try again. These errors are typically
913   # present due to the copy protection that ddrescue removed.
914   grep -q "SCR moves" $dvdauthorlog
915   while [ $? == 0 ]; do
916     # fix bad vobs that get the "SCR moves backwards" error:
917     #  STAT: Processing VTS_01_0.VOB...
918     #  ERR:  SCR moves backwards, remultiplex input.
919     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
920     if [[ ! -f "$badvob" ]]; then
921       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
922     fi
923     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
924     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
925     mv -f $badvob.fixed $badvob
926     echo "-> Creating DVD video $dest/$dvdname"
927     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
928     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
929     grep -q "SCR moves" $dvdauthorlog
930   done
931 }
932
933 function get_feature_title {
934   source="$1"
935   # if a feature title was given on the command line, use it
936   if [ $feature_title_override -ne 0 ]; then
937     feature_title=$feature_title_override
938     return 0
939   fi
940   # otherwise, use lsdvd to figure it out
941   if [ $ripdvd -eq 1 ]; then
942     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
943   else 
944     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
945   fi
946 }
947
948 function create_main_vob_with_cat {
949   # cd to the feature title DVD folder
950   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
951   if [ $? != 0 ]; then
952     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
953   fi
954
955   # concatenate all the VOBs together into 1 giant VOB
956   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
957   cat $vobs > "$tmpdir/$dvdname.VOB"
958
959   # cd back to the dir we started from
960   popd > /dev/null 2>&1
961 }
962
963 function create_main_vob_with_mplayer {
964
965   # argument processing  
966   source="$1"
967   remove_dumplog=$2
968
969   # make sure we have a valid feature title
970   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
971     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
972   fi
973
974   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
975   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
976     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
977     msg="$msg We also detected another condition that requires us to use dumpstream. "
978     msg="$msg\n    Unable to rip this DVD in the mode you requested."
979     fatal_and_exit "$msg"
980   fi
981
982   # use mplayer to create the main VOB file
983   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
984   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
985   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
986   if [ $? != 0 ]; then
987     cat $dumplog | grep -v "^A:" >> "$logfile"
988     fatal_and_exit "-E- Mplayer Failed"
989   fi
990   cat $dumplog | grep -v "^A:" >> "$logfile"
991   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
992 }
993
994 function get_audio_id_from_iso {
995   # Adjust our audio ID to find the english audio stream
996   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
997   iso="$1"
998   aidcheck=`tempfile`
999   aid=$default_aid
1000   alang=$default_alang
1001   if [ $aid_override -lt 0 ]; then 
1002     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1003     grep -q "aid: $aid" $aidcheck
1004     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1005       (( aid = aid + 1 ))
1006       grep -q "aid: $aid" $aidcheck
1007     done
1008     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1009   else
1010     aid=$aid_override
1011   fi
1012   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1013   # mencoder default DVD audio track language selection (english)
1014   lang_opts="-aid $aid -alang $alang"
1015 }
1016
1017 function get_crop_from_iso { 
1018   FRAMES=10000
1019   echo "-> Detecting black frame border crop value from ISO file"
1020   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1021   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1022   [[ -e "md5sums" ]] && rm -f "md5sums"
1023   CROP=`cat $dumplog | grep CROP | tail -1`
1024   echo "   Found crop value of $CROP" >> "$logfile"
1025   CROP=${CROP#* crop=}
1026   CROP=${CROP%%\).*}
1027   typeset -i CROPCHECK
1028   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1029   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1030   if [ -z "$CROP" ]; then
1031     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1032     return
1033   fi
1034   if [ $CROPCHECK -lt 0 ]; then 
1035     CROP=""
1036   else 
1037     CROP=",crop=$CROP"
1038   fi
1039   echo "   Setting mencoder crop filter to: $CROP"
1040 }
1041
1042 function get_crop_from_vob { 
1043   FRAMES=10000
1044   echo "-> Detecting black frame border crop value from VOB file"
1045   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1046   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1047   [[ -e "md5sums" ]] && rm -f "md5sums"
1048   CROP=`cat $dumplog | grep CROP | tail -1`
1049   echo "   Found crop value of $CROP" >> "$logfile"
1050   CROP=${CROP#* crop=}
1051   CROP=${CROP%%\).*}
1052   typeset -i CROPCHECK
1053   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1054   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1055   if [ -z "$CROP" ]; then
1056     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1057     return
1058   fi
1059   if [ $CROPCHECK -lt 0 ]; then 
1060     CROP=""
1061   else 
1062     CROP=",crop=$CROP"
1063   fi
1064   echo "   Setting mencoder crop filter to: $CROP"
1065 }
1066
1067 function get_audio_track_from_vob {
1068   # Adjust our audio ID to find the english audio stream
1069   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1070   vob="$1"
1071   handbrake_cli="$2"
1072   aidcheck=`tempfile`
1073   aid=$default_aid
1074   alang=$default_alang
1075   if [ $aid_override -lt 0 ]; then 
1076     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1077     grep -q "Found audio stream: $aid" $aidcheck
1078     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1079       (( aid = aid + 1 ))
1080       grep -q "Found audio stream: $aid" $aidcheck
1081     done
1082     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1083   else 
1084     aid=$aid_override
1085   fi
1086   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1087
1088   # convert the aid we found into hex
1089   aid_hex=`echo "obase=16; $aid" | bc`
1090   
1091   # extract the audio streams in the vob
1092   #ffmpeg -i "$vob" > $aidcheck 2>&1
1093   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1094   
1095   # find the stream that matches our aid
1096   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1097   stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1098  
1099   # extract the track number that handbrake uses
1100   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1101   track=`expr match "$stream" '^\([0-9]*\):'`
1102
1103   if [ -n "$track" ]; then   
1104     echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1105   fi
1106 }
1107
1108 function get_audio_id_from_vob {
1109   # Adjust our audio ID to find the english audio stream
1110   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1111   vob="$1"
1112   aidcheck=`tempfile`
1113   aid=$default_aid
1114   alang=$default_alang
1115   if [ $aid_override -lt 0 ]; then 
1116     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1117     grep -q "Found audio stream: $aid" $aidcheck
1118     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1119       (( aid = aid + 1 ))
1120       grep -q "Found audio stream: $aid" $aidcheck
1121     done
1122     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1123   else 
1124     aid=$aid_override
1125   fi
1126   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1127   # mencoder default DVD audio track language selection (english)
1128   lang_opts="-aid $aid -alang $alang"
1129 }
1130
1131 function check_vob_for_corrupted_start {
1132   # check to see if the beginning of the DVD has a form of copy protection
1133   # where they have deliberately broken the first X number of frames of the DVD.
1134   # If we don't skip these, our resulting VOB file will not play.
1135   badvobcheck=`tempfile`
1136   endpos=360
1137   skip=0
1138   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1139   if [ $? != 0 ]; then
1140     fatal_and_exit "-E- Mencoder Failed"
1141   fi
1142   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1143   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1144     (( skip = skip + 5 ))
1145     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1146     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1147     if [ $? != 0 ]; then
1148       fatal_and_exit "-E- Mencoder Failed"
1149     fi
1150     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1151   done
1152   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1153
1154   # cat the giant VOB into mencoder to create a playable VOB file
1155   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1156   if [ $? != 0 ]; then
1157     fatal_and_exit "-E- Mencoder Failed"
1158   fi
1159 }
1160
1161 function check_vob_for_completeness {
1162   # check to make sure we got out a complete VOB.
1163   # there is another kind of copy protection where the VOB's may
1164   # have "MPG EOF" frames in the middle of the stream. 
1165   # this causes mencoder to not process the entire VOB, and exit without any errors.
1166   # detect this by seeing how much smaller the dst vob is from the src vob.
1167   MAX_FILESIZE_DELTA_PERCENT=70
1168   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1169   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1170   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1171   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1172     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1173     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1174     create_main_vob_with_mplayer "$isofile"
1175     [[ -e "$dumplog" ]] && rm -f $dumplog
1176     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1177     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1178     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1179       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1180     fi
1181   fi
1182 }
1183
1184 function check_vob_for_too_many_video_packets {
1185   # If our earlier algorithm to work around this failed, throw an error.
1186   # check to see if this DVD has a protection scheme we don't know how to work around
1187   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1188   # for some reason, the video is black, while the audio rolls, then the video finally comes
1189   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1190   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1191   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1192   grep -q "Too many video packets in the buffer:" "$logfile"
1193   if [ $? == 0 ]; then
1194     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1195     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1196     create_main_vob_with_mplayer "$isofile"
1197     grep -q "Too many video packets in the buffer:" $dumplog
1198     if [ $? == 0 ]; then
1199       [[ -e "$dumplog" ]] && rm -f $dumplog
1200       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1201     fi
1202     [[ -e "$dumplog" ]] && rm -f $dumplog
1203   fi
1204 }
1205
1206 function check_vob_for_a52_crc_errors {
1207   # Let's see if we can playback our newly created VOB file without any errors.
1208   # if there are issues, let's detect them now, and try to recreate the VOB
1209   # there are some forms of copy protection that have missed above, that evidence
1210   # themselves when we try to playback the VOB file. This was added to deal with
1211   # the "a52: CRC check failed" copy protection scheme.
1212   MAX_ERRORS=10
1213   ENDPOS=120
1214   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1215   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1216   cat $dumplog | grep -v "^A:" >> "$logfile"
1217   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1218   if [ $errors -gt $MAX_ERRORS ]; then
1219     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1220     create_main_vob_with_mplayer "$isofile"
1221     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1222     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1223     if [ $? != 0 ]; then
1224       cat $dumplog | grep -v "^A:" >> "$logfile"
1225       fatal_and_exit "-E- Mplayer Failed"
1226     fi
1227     cat $dumplog | grep -v "^A:" >> "$logfile"
1228     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1229     if [ $errors -gt $MAX_ERRORS ]; then
1230       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1231     fi
1232   fi
1233   [[ -e "$dumplog" ]] && rm -f $dumplog
1234 }
1235
1236 function calculate_bitrate_from_target_size {
1237   # determine what our bitrate needs to be if a target size was specified instead
1238   if [ $target_size -ne 0 ]; then
1239     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1240     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1241     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1242   fi
1243 }
1244
1245 function create_dvdauthor_dvd_xml_file {
1246   # make a dvdauthor xml menu file to create a valid DVD video from 
1247   # this script does a good job, but we'll still need to clean it up a bit after it runs
1248   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1249   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1250   if [ $? != 0 ]; then
1251     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1252   fi
1253
1254   # replace the first line of the xml file to remove the bad dest path
1255   awk -v line=1 -v new_content="<dvdauthor>" '{
1256     if (NR == line) {
1257       print new_content;
1258     } else {
1259       print $0;
1260     }
1261   }' dvd.xml > dvd.xml.new
1262   mv -f dvd.xml.new dvd.xml
1263   if [ $? != 0 ]; then
1264     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1265   fi
1266
1267   # remove the "<video " property line from the xml file
1268   cat dvd.xml | grep -v "<video" > dvd.xml.new
1269   mv -f dvd.xml.new dvd.xml
1270   if [ $? != 0 ]; then
1271     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1272   fi
1273   
1274   # remove the extra <pgc>..</pgc> pairs
1275   cat dvd.xml | awk 'BEGIN {x=1}
1276   {
1277     if ($0~"</pgc>") {x=0}
1278     if (x==1) {print $0}
1279     if ($0~"<pgc>") {x=1}
1280   }' > dvd.xml.new
1281   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1282   mv -f dvd.xml.new dvd.xml
1283   if [ $? != 0 ]; then
1284     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1285   fi
1286
1287   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1288   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1289   mv -f dvd.xml.new dvd.xml
1290   if [ $? != 0 ]; then
1291     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1292   fi
1293 }
1294
1295 function check_for_mplayer_dumpstream_incompatibility {
1296
1297   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1298
1299   if [ ! -e "$vobfile" ]; then
1300     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1301     # A DVD that has 99 titles, where the longest title isn't the main feature
1302     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1303     # out what the feature title is. This script will run through that flow if we
1304     # set use_mplayer_dumpstream to 0. Check for this here.
1305     if [ $ripdvd -eq 1 ]; then
1306       lsdvd $dev | grep -q "Title: 99"
1307     else
1308       lsdvd "$isofile" | grep -q "Title: 99"
1309     fi
1310     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1311     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1312       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1313         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1314         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1315         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1316         invalid_feature_title=1
1317       else 
1318         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1319         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1320         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1321         use_mplayer_dumpstream=0
1322         invalid_feature_title=1
1323       fi
1324       return
1325     fi
1326   fi
1327
1328   # There is another form of protection that causes the mplayer dumpstream to fail. 
1329   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1330   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1331   # problem before continuing.
1332   if [ -e "$vobfile" ]; then
1333     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1334     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1335     grep -q "Too many audio packets in the buffer" $dumplog
1336     if [ $? == 0 ]; then
1337       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1338       use_mplayer_dumpstream=0
1339       mplayer_dumpstream_incompatibility=1
1340     fi
1341     [[ -e "$dumplog" ]] && rm -f $dumplog
1342   fi
1343 }
1344
1345 function fill_mythvideo_metadata {
1346
1347   # This function must be passed the filename as an argument
1348   # The filename must be a full path to the file
1349   filename="$1"
1350
1351   # Make sure the fill mythvideo metadata option has been set to 1
1352   if [ $fill_mythvideo_metadata -eq 0 ]; then
1353     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1354     return 0
1355   fi
1356
1357   # If the fill mythvideo metadata script is present, run it
1358   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1359   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1360     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1361     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1362   else
1363     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1364     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1365   fi
1366 }
1367
1368 # remove the intermediate VOB file
1369 function remove_intermediate_vob_file {
1370   if [ $keep_intermediate_files -eq 0 ]; then
1371     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1372   else
1373     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1374   fi
1375 }
1376
1377 # remove the original DVD image 
1378 function remove_intermediate_iso_file {
1379   [[ $keep_isofile -eq 1 ]] && return 1
1380   if [ $keep_intermediate_files -eq 0 ]; then
1381     [[ -e "$isofile" ]] && rm "$isofile"
1382   else
1383     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1384   fi
1385 }
1386
1387 # remove the intermediate dvdbackup folder
1388 function remove_intermediate_dvdbackup_folder {
1389   if [ $keep_intermediate_files -eq 0 ]; then
1390     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1391   else
1392     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1393   fi
1394 }
1395
1396 ##############################################################################################
1397 # MAIN
1398 ##############################################################################################
1399
1400 # Make a note of when this DVD rip started
1401 date=`date`
1402 echo -e "\n$date DVD rip started" >> "$logfile"
1403 echo "$cmd" >> "$logfile"
1404
1405 # Rip the DVD - Mirror Mode
1406 if [ $mirror_mode -eq 1 ]; then
1407   echo "-> Ripping DVD $dvdname to $dest"
1408
1409   # use ddrescue to make an ISO image of the disk
1410   make_dvd_iso_image "$dest/$dvdname.iso"
1411
1412   # add this video data to the mythtv DB
1413   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1414
1415   # eject the disk upon completion
1416   if [ $eject_disk -ne 0 ]; then
1417     eject -T $dev
1418   fi
1419
1420   date=`date`
1421   echo "$date DVD rip completed" | tee -a "$logfile"
1422
1423   if [[ -n "$mailto" ]]; then
1424     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1425   fi
1426
1427 fi
1428
1429 # Rip the DVD - Main Title Feature Only
1430 if [ $mirror_mode -eq 0 ]; then
1431
1432   # Rip image from DVD
1433   if [ $ripdvd -eq 1 ]; then
1434     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1435     # use ddrescue to make an ISO image of the disk
1436     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1437   fi
1438
1439   # Rip image from DVD path
1440   if [ -n "$dvdpath" ]; then
1441     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1442     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1443   fi
1444
1445   # make sure our isofile value is set
1446   if [ -z "$isofile" ]; then
1447     isofile="$tmpdir/$dvdname.iso"
1448   fi
1449      
1450   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1451
1452     if [ ! -e "$vobfile" ]; then
1453       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1454       
1455       # get the feature title from the ISO
1456       get_feature_title "$isofile"
1457  
1458       # get the crop value from the ISO
1459       get_crop_from_iso
1460
1461       # check for mplayer dumpstream incompatibilities
1462       # if they exist, this method will set this mode to 0.
1463       check_for_mplayer_dumpstream_incompatibility
1464
1465       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1466
1467         # get our audio id from the ISO file
1468         get_audio_id_from_iso "$isofile"
1469
1470         # create our main VOB file from the ISO
1471         create_main_vob_with_mplayer "$isofile"
1472      
1473         # remove the intermediate VOB file
1474         remove_intermediate_vob_file
1475
1476         # it's possible that our VOB is still corrupted in some manner
1477         # check to make sure it is still a good VOB before continuing.
1478         check_for_mplayer_dumpstream_incompatibility
1479
1480       fi
1481  
1482       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1483
1484         # use dvdbackup to make a DVD folder of the feature title
1485         make_dvdbackup_folder_image
1486   
1487         # create our main VOB file
1488         create_main_vob_with_cat
1489
1490         # get our audio id from the VOB file
1491         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1492   
1493         # check for corrupted VOB start
1494         check_vob_for_corrupted_start
1495  
1496         # check to make sure our VOB is complete
1497         check_vob_for_completeness
1498
1499         # check to make sure our VOB doesn't have too many video packets
1500         check_vob_for_too_many_video_packets
1501
1502         # check to make sure our VOB doesn't have a52 crc errors
1503         check_vob_for_a52_crc_errors
1504
1505         # remove the intermediate VOB file
1506         remove_intermediate_vob_file
1507
1508       fi
1509
1510       # remove the intermediate ISO file
1511       remove_intermediate_iso_file
1512
1513     else
1514       if [ "$encoder" != "handbrake" ]; then 
1515         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1516         # get our audio id from the VOB file
1517         get_audio_id_from_vob "$vobfile"
1518         # get the crop value from the VOB
1519         get_crop_from_vob
1520       fi
1521     fi
1522
1523     # eject the DVD disk since we are finished with it
1524     [ $eject_disk -eq 2 ] && eject -T $dev
1525
1526     # encode the VOB file to a compressed file format
1527     if [ $make_final_dest_comp -eq 1 ]; then
1528       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1529
1530       # determine what our bitrate needs to be if a target size was specified instead
1531       calculate_bitrate_from_target_size        
1532      
1533       # encode the vob file into a compressed file format
1534       if [[ "$encoder" == "mencoder" ]]; then 
1535         encode_vob_file_mencoder
1536       fi
1537       if [[ "$encoder" == "handbrake" ]]; then
1538         encode_vob_file_handbrake
1539       fi
1540
1541       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1542         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1543         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1544       else
1545         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1546         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1547       fi
1548     fi
1549
1550   # add this video data to the mythtv DB
1551   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1552   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1553     
1554   else
1555
1556   # use dvdbackup to make a DVD folder of the feature title
1557   make_dvdbackup_folder_image
1558
1559   # cd to the feature title DVD folder
1560   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1561   if [ $? != 0 ]; then
1562     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1563   fi
1564   
1565   # create the dvd.xml file for dvdauthor
1566   create_dvdauthor_dvd_xml_file  
1567
1568   # make the final DVD folder image
1569   make_dvdauthor_folder_image
1570
1571   # add this video data to the mythtv DB
1572   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1573  
1574   # cd back to the dir we started from
1575   popd > /dev/null 2>&1
1576
1577   if [ $make_final_dest_iso -eq 1 ]; then
1578
1579     # make an iso image out of our directory
1580     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1581    
1582     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1583     if [ -s "$dest/$dvdname.iso" ]; then
1584       if [ $make_final_dest_folder -eq 0 ]; then
1585         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1586         # remove the folder of the DVD image now that we have a .iso version of it
1587         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1588       fi
1589     else
1590       # we created an empty iso file, remove it
1591       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1592       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1593       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1594     fi
1595  
1596     # add this video data to the mythtv DB
1597     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1598
1599   fi
1600
1601   fi
1602
1603   # remove the ddrescue DVD ISO image
1604   remove_intermediate_iso_file
1605
1606   # remove the tmp dvdbackup folder of the DVD image
1607   remove_intermediate_dvdbackup_folder
1608
1609   # eject the DVD disk upon completion
1610   [ $eject_disk -eq 1 ] && eject -T $dev
1611
1612   date=`date`
1613   echo "$date DVD rip completed" | tee -a "$logfile"
1614
1615   if [[ -n "$mailto" ]]; then
1616     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1617   fi
1618
1619 fi
1620
1621 ##############################################################################################